package org.jvnet.hifaces.binding;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;
import javax.faces.el.PropertyNotFoundException;

public abstract class RelativeValueBinding<T, V> extends ValueBinding<V> {

	private final Class<? extends T> type;

	private final javax.faces.el.ValueBinding baseValueBinding;

	public RelativeValueBinding(final Class<? extends T> type,
			final javax.faces.el.ValueBinding baseValueBinding) {
		super();
		this.type = type;
		this.baseValueBinding = baseValueBinding;
	}

	@SuppressWarnings("unchecked")
	@Override
	public V getValue(FacesContext facesContext) throws EvaluationException,
			PropertyNotFoundException {
		final T base = (T) baseValueBinding.getValue(facesContext);
		return get(base);
	}

	@Override
	public boolean isReadOnly(FacesContext facesContext)
			throws EvaluationException, PropertyNotFoundException {
		return true;
	}

	@Override
	public void setValue(FacesContext facesContext, Object value)
			throws EvaluationException, PropertyNotFoundException {
		final T base = (T) baseValueBinding.getValue(facesContext);
		set(base, (V) value);
	}

	public abstract V get(T base);

	public void set(T base, V value) {
		throw new UnsupportedOperationException();
	}
}
