package org.jvnet.hifaces.binding.calendar;

import java.util.Calendar;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

import org.jvnet.hifaces.binding.message.MessageValueBinding;


public class NestedCalendarValueBinding extends MessageValueBinding {

  protected final ValueBinding valueBinding;

  public static final String DATE_FORMAT_MESSAGE_ID = "_dateFormat";
  public static final String DATETIME_FORMAT_MESSAGE_ID = "_dateTimeFormat";
  public static final String TIME_FORMAT_MESSAGE_ID = "_timeFormat";

  public NestedCalendarValueBinding(String messageId, final ValueBinding valueBinding) {
    super(messageId);
    this.valueBinding = valueBinding;
  }

  protected Object[] getArguments(FacesContext facesContext) {
    final Calendar calendar = (Calendar) valueBinding.getValue(facesContext);
    return new Object[]{ calendar.getTime() };
  }

  public static ValueBinding newDateValueBinding(ValueBinding valueBinding) {
    return new NestedCalendarValueBinding(DATE_FORMAT_MESSAGE_ID, valueBinding);

  }

  public static ValueBinding newDateTimeValueBinding(ValueBinding valueBinding) {
    return new NestedCalendarValueBinding(DATETIME_FORMAT_MESSAGE_ID, valueBinding);

  }

  public static ValueBinding newTimeValueBinding(ValueBinding valueBinding) {
    return new NestedCalendarValueBinding(TIME_FORMAT_MESSAGE_ID, valueBinding);

  }
}
