package org.jvnet.hifaces.components.tabbedpane;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.apache.myfaces.shared.renderkit.RendererUtils;
import org.apache.myfaces.shared.renderkit.html.HTML;

public class HtmlTabbedPaneRenderer extends
		org.apache.myfaces.shared.renderkit.html.HtmlRenderer {

	public boolean getRendersChildren() {
		return true;
	}

	public void encodeBegin(FacesContext context, UIComponent component)
			throws IOException {
	}

	public void encodeChildren(FacesContext context, UIComponent component)
			throws IOException {
	}

	public void encodeEnd(FacesContext facesContext, UIComponent component)
			throws IOException {
		RendererUtils.checkParamValidity(facesContext, component,
				HtmlPanelTabbedPane.class);
		final ResponseWriter responseWriter = facesContext.getResponseWriter();

		final HtmlPanelTabbedPane pane = (HtmlPanelTabbedPane) component;

		responseWriter.startElement(HTML.TABLE_ELEM, component);
		responseWriter.writeAttribute(HTML.CELLSPACING_ATTR, "0", null);
		responseWriter.writeAttribute(HTML.CELLPADDING_ATTR, "0", null);
		responseWriter.writeAttribute(HTML.CLASS_ATTR, pane
				.getTableStyleClass(), null);
		responseWriter.writeAttribute(HTML.ID_ATTR, component
				.getClientId(facesContext), null);
		final int selectedIndex = pane.getSelectedIndex();

		{
			responseWriter.startElement(HTML.TR_ELEM, component);
			responseWriter.writeAttribute(HTML.CLASS_ATTR, pane
					.getLabelsRowStyleClass(), null);

			{
				responseWriter.startElement(HTML.TD_ELEM, component);
				responseWriter.writeAttribute(HTML.CLASS_ATTR, pane
						.getPreColumnStyleClass(), null);
				responseWriter.write("&#xA0;");
				responseWriter.endElement(HTML.TD_ELEM);
			}

			for (int index = 0; index < pane.getChildCount(); index++) {
				final UIComponent child = (UIComponent) pane.getChildren().get(
						index);
				if (index != 0) {

					responseWriter.startElement(HTML.TD_ELEM, component);
					responseWriter.writeAttribute(HTML.CLASS_ATTR, pane
							.getMidColumnStyleClass(), null);
					responseWriter.write("&#xA0;");
					responseWriter.endElement(HTML.TD_ELEM);

				}
				{
					responseWriter.startElement(HTML.TD_ELEM, component);
					if (selectedIndex == index) {
						responseWriter.writeAttribute(HTML.CLASS_ATTR,
								pane.getActiveColumnStyleClass(), null);
					} else {
						responseWriter.writeAttribute(HTML.CLASS_ATTR,
								pane.getInactiveColumnStyleClass(), null);
					}
					final UIComponent label = child.getFacet("label");
					if (label != null) {
						RendererUtils.renderChild(facesContext, label);
					}
					responseWriter.endElement(HTML.TD_ELEM);
				}
			}
			{
				responseWriter.startElement(HTML.TD_ELEM, component);
				responseWriter.writeAttribute(HTML.CLASS_ATTR, pane
						.getPostColumnStyleClass(), null);
				responseWriter.write("&#xA0;");
				responseWriter.endElement(HTML.TD_ELEM);
			}
			responseWriter.endElement(HTML.TR_ELEM);
		}

		{
			responseWriter.startElement(HTML.TR_ELEM, component);
			responseWriter.writeAttribute(HTML.CLASS_ATTR, pane
					.getContentsRowStyleClass(), null);

			{
				responseWriter.startElement(HTML.TD_ELEM, component);
				responseWriter.writeAttribute(HTML.CLASS_ATTR, pane
						.getContentColumnStyleClass(), null);
				responseWriter.writeAttribute(HTML.COLSPAN_ATTR, (1 + pane.getChildCount() * 2), null);

				for (int index = 0; index < pane.getChildCount(); index++) {
					final UIComponent child = (UIComponent) pane.getChildren()
							.get(index);
					if (selectedIndex == index) {
						final UIComponent content = child.getFacet("content");
						RendererUtils.renderChild(facesContext, content);
					}
				}
				responseWriter.endElement(HTML.TD_ELEM);
			}
			responseWriter.endElement(HTML.TR_ELEM);
		}
		responseWriter.endElement(HTML.TABLE_ELEM);
	}
}
