package org.jvnet.hifaces.components.templatedpanel;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

public class HtmlPanelTemplatedPanel extends AbstractTemplatedPanel {

	public static final String COMPONENT_TYPE = "org.jvnet.hifaces.HtmlPanelTemplatedPanel";

	public static final String COMPONENT_FAMILY = "javax.faces.Panel";

	public static final String DEFAULT_RENDERER_TYPE = "org.jvnet.hifaces.TemplatedPanel";

	public HtmlPanelTemplatedPanel() {
		setRendererType(DEFAULT_RENDERER_TYPE);
	}

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	private String fragmentId = null;

	public void setFragmentId(String layout) {
		this.fragmentId = layout;
	}

	public String getFragmentId() {
		if (this.fragmentId != null)
			return this.fragmentId;
		final ValueBinding vb = getValueBinding("fragmentId");
		return vb != null ? (String) vb.getValue(getFacesContext()) : null;
	}

	public Object saveState(FacesContext context) {
		Object values[] = new Object[2];
		values[0] = super.saveState(context);
		values[1] = fragmentId;
		return ((Object) (values));
	}

	public void restoreState(FacesContext context, Object state) {
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		fragmentId = (String) values[1];
	}

	private Template template;

	public void setTemplate(Template template) {
		this.template = template;
	}

	public Template getTemplate() throws Exception {
		if (template != null) {
			return template;
		} else {
			final ValueBinding vb = getValueBinding("template");
			if (vb != null) {
				return (Template) vb.getValue(getFacesContext());
			} else {
				final String templateName = getTemplateName();
				final String fragmentId = getFragmentId();
				final Template template = getTemplate(templateName, fragmentId);
				return template;
			}
		}
	}
}
