package org.jvnet.hifaces.components.templatedpanel;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.render.Renderer;

public class HtmlTemplatedPanelRenderer extends Renderer {

  public boolean getRendersChildren() {
    return true;
  }
  
  public void encodeBegin(FacesContext context, UIComponent component) throws IOException {
  }

  public void encodeChildren(FacesContext context, UIComponent component) throws IOException {
  }

  public void encodeEnd(FacesContext facesContext, UIComponent component) throws IOException {

    final HtmlPanelTemplatedPanel panel = (HtmlPanelTemplatedPanel) component;

    final String templateName = panel.getTemplateName();

    final String fragmentId = panel.getFragmentId();
    final Template template;
    try {
      template = panel.getTemplate();
    }
    catch (Exception ex) {
      IOException exception = new IOException("Template with name ["
          + templateName
          + "] and fragment id ["
          + fragmentId
          + "] could not be retrieved.\n");
      exception.initCause(ex);
      throw exception;
    }
    template.render(facesContext, panel);
  }
}
