/*
 * Created on 21.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.jvnet.hifaces.convert;

import java.util.Map;

import javax.faces.component.StateHolder;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

public class EnumsConverter implements Converter, StateHolder {

	private static final String CONVERSION_MESSAGE_ID = "org.jvnet.hifaces.convert.EnumsConverter.CONVERSION";

	public static final String CONVERTER_ID = "org.jvnet.hifaces.Enums";

	private Map enumMap;

	public Map getEnumMap() {
		return enumMap;
	}

	public void setEnumMap(Map enumMap) {
		this.enumMap = enumMap;
	}

	public EnumsConverter() {
	}

	public EnumsConverter(Map enumMap) {
		this.enumMap = enumMap;
	}

	public Object getAsObject(FacesContext facesContext, UIComponent component,
			String value) {
		if ("#".equals(value)) {
			return null;
		}
		if (value != null) {
			final Map enumMap = getEnumMap();
			if (enumMap != null || enumMap.containsKey(value)) {
				return enumMap.get(value);
			} else {
				throw new ConverterException(MessageUtils.getErrorMessage(
						facesContext, CONVERSION_MESSAGE_ID, new Object[] {
								value, component.getId() }));
			}
		}
		return null;
	}

	public String getAsString(FacesContext facesContext, UIComponent component,
			Object object) {
		if (object == null)
			return "#";
		else
			return object.toString();
	}

	private boolean _transient;

	public boolean isTransient() {
		return _transient;
	}

	public void setTransient(boolean newTransientValue) {
		this._transient = newTransientValue;
	}

	public void restoreState(FacesContext facesContext, Object state) {
		final Object[] values = (Object[]) state;
		enumMap = (Map) values[0];
	}

	public Object saveState(FacesContext facesContext) {
		Object[] values = new Object[1];
		values[0] = enumMap;
		return values;
	}
}