package org.jvnet.hifaces.convert;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

public final class StringConverter implements Converter {

	private static final String CONVERSION_MESSAGE_ID = "org.jvnet.hifaces.convert.StringConverter.CONVERSION";

	public static final String CONVERTER_ID = "org.jvnet.hifaces.String";

	public StringConverter() {
	}

	public Object getAsObject(FacesContext facesContext,
			UIComponent uiComponent, String value) {
		if (facesContext == null)
			throw new NullPointerException("facesContext");
		if (uiComponent == null)
			throw new NullPointerException("uiComponent");
		if (value == null)
			return null;
		else if ("".equals(value.trim()))
			return null;

		return value;
	}

	public String getAsString(FacesContext facesContext,
			UIComponent uiComponent, Object value) {
		if (facesContext == null)
			throw new NullPointerException("facesContext");
		if (uiComponent == null)
			throw new NullPointerException("uiComponent");

		if (value == null) {
			return "";
		}
		if (value instanceof String) {
			return (String) value;
		}
		try {
			return value.toString();
		} catch (Exception e) {
			throw new ConverterException(e);
		}
	}

}