package org.jvnet.hifaces.function;


public class Property1<R, P> {

	private final Class<? extends R> type;

	private final Function1<R, P> getter;

	private final Function2<?, P, R> setter;

	public Property1(final Function1<R, P> getter,
			final Function2<?, P, R> setter) {
		this.type = getter.getType();
		this.getter = getter;
		this.setter = setter;
	}

	public Property1(final Function1<R, P> getter) {
		this.type = getter.getType();
		this.getter = getter;
		this.setter = null;
	}

	public Class<? extends R> getType() {
		return type;
	}

	public Property0<R> bind(P arg) {
		final Function0<R> getter = this.getter.bind(arg);
		if (this.setter == null) {
			return new Property0<R>(getter);
		} else {
			final Function1<?, R> setter = this.setter.bind0(arg);
			return new Property0<R>(getter, setter);
		}
	}

	public Property0<R> compose(Function0<P> arg) {
		final Function0<R> getter = this.getter.compose(arg);
		if (this.setter == null) {
			return new Property0<R>(getter);
		} else {
			final Function1<?, R> setter = this.setter.compose0(arg);
			return new Property0<R>(getter, setter);
		}
	}
}
