package org.jvnet.hifaces.lifecycle;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.faces.lifecycle.Lifecycle;
import javax.faces.lifecycle.LifecycleFactory;

public class SessionSynchronizedLifecycleFactory extends LifecycleFactory {

	private javax.faces.lifecycle.LifecycleFactory parent;

	public SessionSynchronizedLifecycleFactory(
			javax.faces.lifecycle.LifecycleFactory parent) {
		this.parent = parent;
	}

	private final Map<String, Lifecycle> lifecycles = new HashMap<String, Lifecycle>();

	@Override
	public void addLifecycle(String lifecycleId, Lifecycle lifecycle) {
		parent.addLifecycle(lifecycleId, lifecycle);
	}

	@Override
	public Iterator getLifecycleIds() {
		return parent.getLifecycleIds();
	}

	@Override
	public Lifecycle getLifecycle(String lifecycleId) {
		synchronized (lifecycles) {
			if (lifecycles.containsKey(lifecycleId)) {
				return lifecycles.get(lifecycleId);
			} else {
				final Lifecycle parentLifecycle = parent
						.getLifecycle(lifecycleId);
				final Lifecycle lifecycle = new SessionSynchronizedLifecycle(
						parentLifecycle);
				lifecycles.put(lifecycleId, lifecycle);
				return lifecycle;
			}
		}
	}
}
