package org.jvnet.hifaces.renderkit.html.ext;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlCommandButton;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.apache.myfaces.shared.config.MyfacesConfig;
import org.apache.myfaces.shared.renderkit.html.HTML;
import org.apache.myfaces.shared.renderkit.html.HtmlButtonRendererBase;
import org.apache.myfaces.shared.renderkit.html.HtmlRendererUtils;
import org.apache.myfaces.shared.renderkit.html.util.FormInfo;

public class HtmlButtonRenderer extends HtmlButtonRendererBase {

	public static final String RENDERER_TYPE = "org.jvnet.hifaces.Button";

	@Override
	protected StringBuffer buildOnClick(UIComponent uiComponent,
			FacesContext facesContext, ResponseWriter writer)
			throws IOException {
		FormInfo formInfo = findNestingForm(uiComponent, facesContext);
		if (formInfo == null) {
			throw new IllegalArgumentException("Component "
					+ uiComponent.getClientId(facesContext)
					+ " must be embedded in an form");
		}
		String formName = formInfo.getFormName();
		UIComponent nestingForm = formInfo.getForm();

		StringBuffer onClick = new StringBuffer();
		// String commandOnClick = uiComponent.geto (String)
		// uiComponent.getAttributes().get(HTML.ONCLICK_ATTR);

		final String commandOnClick;
		if (uiComponent instanceof HtmlCommandButton) {
			commandOnClick = ((HtmlCommandButton) uiComponent).getOnclick();
		} else {
			commandOnClick = (String) uiComponent.getAttributes().get(
					HTML.ONCLICK_ATTR);
		}

		if (commandOnClick != null) {
			onClick.append(commandOnClick);
			onClick.append(';');
		}

		// call the script to clear the form (clearFormHiddenParams_<formName>)
		// method
		HtmlRendererUtils.appendClearHiddenCommandFormParamsFunctionCall(
				onClick, formName);

		if (MyfacesConfig.getCurrentInstance(facesContext.getExternalContext())
				.isAutoScroll()) {
			org.apache.myfaces.shared.renderkit.html.util.JavascriptUtils
					.appendAutoScrollAssignment(onClick, formName);
		}

		// add hidden field for the case there is no commandLink in the form
		String hiddenFieldName = HtmlRendererUtils
				.getHiddenCommandLinkFieldName(formInfo);
		addHiddenCommandParameter(facesContext, nestingForm, hiddenFieldName);

		return onClick;
	}

}
